﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
  using System;

  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;

  public abstract class PushResultExpression<T> : StatelessExpression {
    protected bool Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
      if (stack.Count < count) return false;

      stack.PushResult(count, templateFunc);
      return true;
    }

    protected bool Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue) {
      if ((stack.Count < count) || stack.Top.Equals(ignoreValue)) return false;

      stack.PushResult(count, templateFunc);
      return true;
    }

    protected bool Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc) {
      if (stack.Count < count) return false;

      var items = stack.Pop(count);
      var result = templateFunc(items);

      resultStack.Push(result);
      return true;
    }
  }
}